# Summary

<!-- 本文檔用于生成 Erg Book 不要添加徽章等 -->

- [基本](./00_basic.md)
- [字面量](./01_literal.md)
- [變量和常量](02_name.md)
- [聲明](./03_declaration.md)
- [函數](./04_function.md)
- [內置函數](./05_builtin_funcs.md)
- [運算符](./06_operator.md)
- [副作用](./07_side_effect.md)
- [程序](./08_procedure.md)
- [內置程序](./09_builtin_procs.md)
- [數組](./10_array.md)
- [元組](./11_tuple.md)
- [字典](./12_dict.md)
- [記錄(Record)](./13_record.md)
- [Set](./14_set.md)
- [類型](./15_type.md)
  - [類型系統](./type/01_type_system.md)
  - [基礎](./type/02_basic.md)
  - [Trait](./type/03_trait.md)
  - [類](./type/04_class.md)
  - [繼承](./type/05_inheritance.md)
  - [NST 與 SST](./type/06_nst_vs_sst.md)
  - [補丁](./type/07_patch.md)
  - [值類型](./type/08_value.md)
  - [屬性類型](./type/09_attributive.md)
  - [區間類型](./type/10_interval.md)
  - [枚舉類型](./type/11_enum.md)
  - [強化類型](./type/12_refinement.md)
  - [代數類型](./type/13_algebraic.md)
  - [依賴類型](./type/14_dependent.md)
  - [量化類型](./type/15_quantified.md)
  - [子類型](./type/16_subtyping.md)
  - [類型轉換](./type/17_type_casting.md)
  - [可變類型](./type/18_mut.md)
  - [高級類型](./type/advanced.md)
    - [默認參數](./type/advanced/default_param.md)
    - [類型擦除](./type/advanced/erasure.md)
    - [存在類型](./type/advanced/existential.md)
    - [GADTs](./type/advanced/GADTs.md)
    - [關鍵字參數](./type/advanced/keyword_param.md)
    - [Kind(類型的類型)](./type/advanced/kind.md)
    - [標記Trait](./type/advanced/marker_trait.md)
    - [可變結構](./type/advanced/mut_struct.md)
    - [幻象類型](./type/advanced/phantom.md)
    - [投影類型](./type/advanced/projection.md)
    - [量化依賴類型](./type/advanced/quantified_dependent.md)
    - [共享引用](./type/advanced/shared.md)
- [迭代器](./16_iterator.md)
- [可變性](./17_mutability.md)
- [所有權](./18_ownership.md)
- [可見性](./19_visibility.md)
- [命名規則](20_naming_rule.md)
- [Lambda](./21_lambda.md)
- [子程序](./22_subroutine.md)
- [閉包](./23_closure.md)
- [模塊](./24_module.md)
- [對象系統](./25_object_system.md)
- [模式匹配](./26_pattern_matching.md)
- [推導式](./27_comprehension.md)
- [擴展語法](./28_spread_syntax.md)
- [裝飾器](./29_decorator.md)
- [錯誤處理](./30_error_handling.md)
- [管道運算符](./31_pipeline.md)
- [與 Python 集成](./32_integration_with_Python.md)
- [包系統](./33_package_system.md)
- [生成器](./34_generator.md)
- [索引](./indexes.md)
